SystemOrganization addCategory: #'Rizel-Tools'!

Object subclass: #RizelAbstractModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 21:58'!
buildBenchmarks
	
	^ (self class allSelectors select: [ :k | k beginsWith: 'bench'  ]).! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:01'!
configurationClass
	^ self subclassResponsability.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 21:25'!
executeBenchmark: aBlock
	^ 10 timesRepeat: aBlock.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:05'!
loadVersion: version
	version load.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:26'!
open
	|browser|
	browser := Rizel new.
	browser model: self.
	browser benchmarks: (self buildBenchmarks).
	browser openWithSpec.
	^ browser.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/13/2012 22:25'!
profile: bench in: version
	self loadVersion: version.
	^ self profilerClass profile: bench usingConfiguration: (self configurationClass).
	! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/13/2012 22:20'!
profilerClass
	^ RzProfilerSpy.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/13/2012 22:03'!
versionLabel
	^ [: v| v versionNumber asString].! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/13/2012 22:00'!
versions
	^ (((self configurationClass project 
						versions select:[ :v|  v importedVersions size >0]) reversed) asOrderedCollection).! !

ComposableModel subclass: #BenchmarkBrowser
	instanceVariableNames: 'classes methods code selectedClass selectedSelector browser ok cancel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:42'!
defaultSpec
	""
	^ { #ComposableSpec.
				#add:. {{#model. #classes. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0.5@0.5). (0@0 corner: 0@0)}}.
				#add:. {{#model. #methods. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0.5@0 corner: 1@0.5). (0@0 corner: 0@0)}}.
				#add:. {{#model. #code. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.5 corner: 1@1). (0@0 corner: 0@25)}}.
				"ok"
				#add:. {{#model. #ok. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (1@1 corner: 1@1). ((-100)@(-25) corner: -50@0)}}.
				"cancel"
				#add:. {{#model. #cancel. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (1@1 corner: 1@1). ((-50)@(-25) corner: 0@0)}}. }.! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:22'!
open
	"
	self open
	"
	|browser|
	browser := BenchmarkBrowser new.
	browser classes: Smalltalk allClasses.
	browser openWithSpec.
	^ browser.! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:31'!
openOn: owner
	"
	self open
	"
	|browser|
	browser := BenchmarkBrowser new.
	browser classes: Smalltalk allClasses.
	browser browser: owner.
	browser openWithSpec.
	^ browser.! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:56'!
title
	^ 'Benchmark Browser'! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:30'!
browser 
	^ browser! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:30'!
browser: aBrowser
	""
	browser := aBrowser.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:00'!
cancel
	cancel ifNil:[ 
		cancel := self instantiate: ButtonModel.
		cancel whenActionPerformedDo: [self close].
		cancel label: 'cancel'. ].
	^ cancel.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:59'!
classes
	^ classes! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 00:00'!
classes: aCollection
	classes items: aCollection.! !

!BenchmarkBrowser methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:56'!
close
	self delete.
	! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:59'!
code
	^ code! !

!BenchmarkBrowser methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:25'!
initializeWidgets
	""
	classes := self instantiate: IconListModel.
	classes whenSelectedItemChanged: [ :selected |
		selected ifNotNilDo: [ :cls |
			selectedClass  := cls.
			self methods: ((cls methodDict values sort: [:a :b | a selector < b selector]) )]. ].
	methods := self instantiate: IconListModel.
	methods whenSelectedItemChanged: [:selected|
		selected ifNotNilDo: [ :m |
			selectedSelector := m.
			code text: (m sourceCode) ]. ].
	methods displayBlock: [:m| m selector].
	code := self instantiate: TextModel.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:59'!
methods
	^ methods! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 00:16'!
methods: aCollection
	methods items: aCollection.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 12:01'!
ok
	ok ifNil:[ 
		ok := self instantiate: ButtonModel.
		ok label: 'Ok'.
		ok whenActionPerformedDo:[
			(selectedClass notNil and:[ selectedSelector notNil]) 
			ifTrue: [ browser addBench: 
				( (selectedSelector methodReference)
					-> [
						(selectedClass new 
							setTestSelector: (selectedSelector asSymbol)) run]).].
			self close.].
		 ].
	^ ok.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:23'!
selectedBenchClass 
	^ selectedClass! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:23'!
selectedBenchSelector
	^ selectedSelector! !

ComposableModel subclass: #Rizel
	instanceVariableNames: 'versions benchmarks model options roassal benchs morphView profilePicker builder result versionLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 22:47'!
defaultSpec
	""
	^ { #ComposableSpec.
				#add:. {{#model. #versions. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.5 corner: 0.3@1). (2@10 corner: 2@2)}}.
				#add:. {{#model. #benchmarks. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0.3@0.5). (2@30 corner: 2@2)}}.
				#add:. {{#model. #options. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0.3@0). (2@25 corner: 2@2)}}.
				"morph"
				#add:. {{#model. #roassal. #defaultSpec.}.
				#layout:. {#FrameLayout.
					#fractions:offsets:. (0.3@0 corner: 1@1). (0@0 corner: 0@0)}}.}.! !

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:12'!
openWith: aConfiguration
	|browser|
	browser := Rizel new.
	browser configurationModel: aConfiguration.
	browser openWithSpec.
	^ browser.! !

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:24'!
title
	^ 'Rizel'! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:05'!
addBench: anAssociation
	""
	benchs add: anAssociation.
	self benchmarks: benchs.! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:01'!
addBenchmark
	""
	BenchmarkBrowser openOn: self.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:07'!
benchmarks
	^ benchmarks! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:04'!
benchmarks: aList
	self benchmarks items: aList.! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalA 8/13/2012 23:38'!
compare
	|profileA profileB merge|

	profileA := model profile: (profilePicker A second) in: (profilePicker A first).
	profileB := model profile: (profilePicker B second) in: (profilePicker B first).

	merge := (profilePicker A  first > profilePicker B first )
				ifTrue: [ (RzProfile merge: profileB with: profileA)]
				ifFalse:[ (RzProfile merge: profileA with: profileB)].
	 "display results"
	 (RzVisualizerMerge on: merge)  visualize.
	! !

!Rizel methodsFor: 'initialization' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:30'!
initialize 
	super initialize.
	benchs  := OrderedCollection new.! !

!Rizel methodsFor: 'initialization' stamp: 'JuanPabloSandovalA 8/13/2012 22:03'!
initializeWidgets
	versions := self instantiate: ListComposableModel.
	versions beMultipleSelection.
	benchmarks := self instantiate: ListComposableModel.
	benchmarks displayBlock: [ :b | b asString].
	benchmarks beMultipleSelection.
	options := self instantiate: RizelOptions.
	options browser: self.
	roassal := self instantiate: RoassalModel.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/13/2012 22:03'!
model: anRizelAbstractModel
	""
	model := anRizelAbstractModel.
	self versions: (model versions).
	versions displayBlock: (model versionLabel).! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:07'!
options
	^ options.! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalA 8/13/2012 22:09'!
profile
	builder := RzBuilder new.
	"defining variables and execution context"
	builder define: #input 
			named: #version 	  
			with: (self selectedVersions). 
	builder define: #input 
			named: #benchmark   
			with: (self selectedBenchmarks).
	"automatic execution"
	result := builder execute: [ :version :benchmark |
		model loadVersion: version.
		[ model perform: benchmark ] timeToRun. ].
	"visualizing results"
	profilePicker := RzVisualizer2D new.
	profilePicker		xValues: (self selectedVersions);
						yValues: (self selectedBenchmarks);
						xLabel: model versionLabel;
						yLabel:[ :bench | bench asString];
						value: [ :version :bench |  result at: (RzVector <== version+bench)];
						padding: 150;
						visualizeOn: (self view).! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:55'!
roassal
	^ roassal.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 22:57'!
selectedBenchmarks
	^ self benchmarks selectedItems asSortedCollection.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 22:57'!
selectedVersions
	^ self versions selectedItems asSortedCollection.! !

!Rizel methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/13/2012 22:02'!
versionLabel: aBlock
	versionLabel := aBlock.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:07'!
versions
	^ versions! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:29'!
versions: aCollection
	self versions items: aCollection! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:55'!
view
	^ roassal view.! !

ComposableModel subclass: #RizelOptions
	instanceVariableNames: 'add profile compare browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelOptions class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 22:38'!
defaultSpec
	<spec>
	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#profile.	#defaultSpec}.
			#addMorph:. {#model.	#compare.	#defaultSpec}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#shrinkWrap.	}! !

!RizelOptions class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:04'!
title
	^ 'Rizel Options'! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:01'!
add
	add ifNil:[
		add := self instantiate: ButtonModel.
		add whenActionPerformedDo: [ browser addBenchmark.].
		add label: '+ bench'.].
	^ add.
! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:26'!
browser
	^ browser.! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:27'!
browser: aBrowser
	browser := aBrowser.! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/11/2012 18:19'!
compare
	compare ifNil:[
		compare := self instantiate: ButtonModel.
		compare whenActionPerformedDo: [ browser compare.].
		compare label: 'Compare'.].
	^ compare.
! !

!RizelOptions methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:05'!
initializeWidgets! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 01:16'!
profile
	profile ifNil:[
		profile := self instantiate: ButtonModel.
		profile whenActionPerformedDo: [ browser profile.].
		profile label: 'Profile'.].
	^ profile.
! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:54'!
window
	^ window! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:55'!
window: aWindow
	""
	window := aWindow.! !

ComposableModel subclass: #RoassalModel
	instanceVariableNames: 'builder container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RoassalModel class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 11:43'!
defaultSpec

	^ { #ComposableSpec.
			#addMorphWrapper:.	
				{#MorphWrapper.
					#morph:. 		{#model. #container.}.
					#fullFrame:. 	{#LayoutFrame.
						#fractions:offsets:.	 (0@0 corner: 1@1).	(2@2 corner: 2@2). }}.}! !

!RoassalModel class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:32'!
title

	^ 'RoassalSpec'! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:54'!
container
	
	^ container.! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 22:20'!
initializeWidgets
	"Initialization code for RadioButtonGroupExample"
	|stack|
	builder := ROMondrianViewBuilder new.
	stack := ROViewStack new addView: (builder container); title: ( builder container title).
	container := (ROMorph on: stack) extent: (300@300).! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 21:52'!
update
	self update: #container.! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 01:20'!
view
	
	^ builder.! !
